# Assets

Assets are the core resource in Panjaya Dubbing Studio. An asset represents a source video you want to dub into different languages.
Each asset can be dubbed into multiple languages, and every language is assigned a unique dubbing ID. You can
optionally add SRT files for better accuracy.

## Get assets

 - [GET /v1/assets/](https://docs.panjaya.ai/apis/assets/assets-get_assets.md): Get a paginated list of your assets.

This endpoint allows you to fetch all your assets with basic metadata, including the asset's current status and associated dubbings.

For available versions of each asset use the Get an asset endpoint.

## Creating a new asset

 - [POST /v1/assets/](https://docs.panjaya.ai/apis/assets/assets-create_asset.md): Creating an asset is the first step to dubbing your video with Panjaya Dubbing Studio.
This endpoint allows you to:

- Upload a source video
- Configure the necessary parameters to initiate the dubbing process

### Uploading the Source Video

- Use the media_url parameter to specify the publicly accessible URL of the source video you want to dub.
- Set the locale field to indicate the original language of the source video.
- It is recommended to set the speakers_count field to the number of distinct speakers in the video, to improve
accuracy and quality of the final video.

### Adding Target Languages

Define the languages into which you want to dub the video:

Panjaya's locale codes adhere to the IETF Language Tag standard, combining ISO 639-1 language codes and ISO 3166-1 country codes. Examples: en-US (English - United States), es-ES (Spanish - Spain), zh-CN (Chinese - China).

For each target language, you may optionally provide a valid SRT file, where applicable, in the designated srt field.

### Trimming the Video

You can optionally use the start_time and end_time parameters to trim your video, allowing you to dub a specific
section of your video.

Both parameters accept a number of seconds from the beginning of the video. For example, if you want to dub only the
first 2 minutes of your video, set end_time to 120.

If not specified, start_time defaults to 0 (beginning of the video), and end_time defaults to the end of the video.


### Status Updates via Callbacks

Optionally, you can configure a callback_url to receive real-time status updates about the dubbing process.

When a callback_url is specified, Panjaya will send updates whenever the status of an asset or any of its dubbing versions changes.

For detailed information on implementing callbacks, refer to the Callbacks section of this documentation.

### Models

The lips_model field specifies which lips model to use when generating versions under this asset.
This parameter is only applicable when lip correction is enabled. You can use it to fine-tune the balance between quality and performance.
* real_face (Default): Our highest-quality lips model, suitable for most use cases.
* real_face_turbo: Optimized for speed - up to 4× faster than real_face, while maintaining high quality.

### Voice Anonymization

The voice_anonymization field allows you to control the degree of voice anonymization applied to the dubbed voices. This is a float between 0.0 (no anonymization, default) and 1.0 (maximum anonymization).
This feature is useful for privacy or compliance requirements, or when you want to mask the original speaker's identity.

- 0.0: No anonymization. The cloned voice will closely match the original speaker.
- 1.0: Maximum anonymization. The voice will sound very different from the original.
- Any value between 0.0 and 1.0 will apply a proportional level of anonymization.

### Background Audio
Panjaya uses our SceneAware audio separation model
to separate speech from background audio in the source video.
This preserves the original background audio in the dubbed result, creating a more natural and immersive experience.

If you already have a clean background audio track (e.g., music and sound effects without speech), you can provide a publicly accessible URL to it
via the background_url field. Panjaya will then use this track directly instead of separating background audio from the source video.

## Uploading a new asset

 - [POST /v1/assets/upload](https://docs.panjaya.ai/apis/assets/assets-upload_asset.md): Upload an asset video file directly to Panjaya Dubbing Studio.

This endpoint allows you to upload a video file directly, saving the need to upload to an external storage service.
It accepts the same parameters as the Create Asset endpoint, except for the media_url parameter,
which is replaced by the video file input.

Note that this endpoint is structured as a multipart/form-data request,
where the request form field contains a JSON-serialized object with the asset parameters, and the video form field contains the video file to be uploaded.

You may additionally provide a background file to upload a clean background audio track.
Refer to Background Audio section under create asset endpoint.

## Get an asset

 - [GET /v1/assets/{asset_id}](https://docs.panjaya.ai/apis/assets/assets-get_asset.md): After creating an asset - either through the Panjaya Dubbing Studio API or by uploading it via the
Panjaya Dubbing Studio web interface - you can easily fetch detailed information about the asset by specifying its asset ID.

This endpoint allows you to access key metadata, including the asset's current status, associated dubbings, and
available versions.

### Asset processing failures
In case of an error while processing the asset, the asset status will be Failed, and the error field in this endpoint's response will contain helpful information for identifying the issue.

It contains an error code and a detailed error message to help you understand and resolve the issue. Here is a list of common error codes for assets:
- invalid_input: The input provided is invalid. Ensure all provided fields match the asset's properties.
- unsupported_media: We didnt find a valid video stream in the media file.
- empty_transcript: No spoken content was identified in the uploaded video.
- missing_audio_track: No audio tracks were found in the source video.
- video_duration_limit_reached: The video duration limit for your account has been reached.
- video_size_limit_reached: The file size of the requested video has exceeded the allowed size limit.
- time_out_of_range: The provided start_time or end_time is out of video range. Ensure that the timestamps are within the video duration.

## Add languages to an existing asset

 - [POST /v1/assets/{asset_id}/languages](https://docs.panjaya.ai/apis/assets/assets-add_languages.md): With this endpoint, you can add new languages to an existing asset. Once you make the request, Panjaya will initiate a new dubbing process for each added language.

Once the process is complete, you will be notified via email and the callback URL, if configured.

